#include	<machine.h>

#include	<apl.h>
#include	<trans.h>
#include	<gfns.h>
#include	<support.h>
#include	<ap_dotnet.h>

gchar taskid[] = GSTR("dotnet_example");

ARRAY *to_dotnet(ARRAY *), *from_dotnet(ARRAY *);

int
#if	defined(DOS)
	main()
#elif	defined(WINDOWS3)
	ap_main(int argc, char *argv[])
#else
	main(int argc, char *argv[])
#endif
{
	ARRAY	*rslt, *larg, *rarg;
	int	fncode;

	startup(2);
	define(GSTR("ToDotNet"), RSLT|MONA, 1);
	define(GSTR("FromDotNet"), RSLT|MONA, 2);

	larg = rarg = rslt = 0;
	setjmp(errbuff);

	while(1)
		{
		larg = freearray(larg);
		rarg = freearray(rarg);
		rslt = freearray(rslt);

		fncode = fromapl();

		switch(fncode)
			{
			case -1:		// AP about to be terminated 
				toapl(0);	// Signal go-ahead to apl    
				fromapl();	// and wait for kill	     
				exit(0); 	// ( For DOS version only. ) 
			case 1:
				rarg = getarray();
				rslt = to_dotnet(rarg);
				break;
			case 2:
				rarg = getarray();
				rslt = from_dotnet(rarg);
				break;
			}
		putarray(rslt);
		}
	return 0;
}

ARRAY *to_dotnet(ARRAY *rarg)
{
GCHANDLE handle = dotnet_ArrayToNet(rarg,0);
ARRAY *rslt;
BOUND	zero=0;

rslt = mkarray(APLLONG, 0, &zero);
rslt->shape[0] = (BOUND)handle;

return rslt;
}

ARRAY *from_dotnet(ARRAY *rarg)
{
ARRAY *rslt = dotnet_ArrayFromNet((GCHANDLE)rarg->shape[0],1);
return rslt;
}
