
//	Copyright (c) 1982 Dyadic Systems Limited	

#if	defined(ERROR_H_INCLUDED)
#else //defined(ERROR_H_INCLUDED)
#define	ERROR_H_INCLUDED
#define EWSFULL	1
#define ESYNTAX	2
#define EINDEX	3
#define ERANK	4
#define ELENGTH	5
#define EVALUE	6
//#define EFORMAT	7	not reffed, clashes with sys/errno.h 
#define ELIMIT	10
#define EDOMAIN	11
#define EOPTION 13
#define ENONCE	16
#define EACCESS	17
#define	EINCOMPAT	36	// in component file range

#define INTERNALERRORS		32768U
#define PROTOTYPEERROR		32768U
#define CRASHFAILEDERROR	32769U
#define CRASHERROR 		32770U
#define COPYERROR 		32771U
#define JUSERROR 		32772U
#define OFFERROR 		32773U

#define EXTERNCUTBACKERROR 	32774U
#define EXTERNRESETERROR 	32775U
#define IOVERERROR		32776U

#define EEXCEPTION		90
#define EDLLEXCEPTION		91
#define ETRANSLATION		92
#define EUNACCEPTABLECHAR	93
#define ENOTCLASSIC		94
#define EAFFIRM			98
#define EINTERNAL		99

#define	WSFULL			error(1)
#define SYNTAX_ERROR		syntax()
#define INDEX_ERROR		error(3)
#define RANK_ERROR		rankerr()
#define LENGTH_ERROR		lengtherr()
#define VALUE_ERROR		error(6)
#define FORMAT_ERROR		error(7)
#define SIZE_ERROR		error(10)
#define LIMIT_ERROR		error(10)
#define DOMAIN_ERROR		domain()
#define HOLD_ERROR		error(12)
#define OPTION_ERROR		error(13)
#define LST_FULL		error(15)
#define	NONCE_ERROR		nonce()
#define	ACCESS_ERROR		error(EACCESS)
#define	TRANSLATION_ERROR	error(ETRANSLATION)

#define EXCEPTION		error(EEXCEPTION)

//			window	Error codes				
#define	CONT_RANK	52
#define	CONT_COLS	53
#define	POSN_ERR	54
#define	SIZE_ERR	55
#define	TYPE_MISMATCH	56
#define	TYPE_ERR	57
#define	ATT_RANK	58
#define	ATT_LENGTH	59
#define	NO_FULLSCR	60
#define	BAD_LINE_CODE	61
#define	KEY_RANK	62
#define	KEY_TYPE	63

#define FS_TIES_USED		error(72)
#define LOST_SLAVE		error(73)
#define P_TAB_FULL		error(76)
#define AP_EXIT			77
#define TRAPERR			84
#define ESTOP			1001
#define DOQSTOP			error(ESTOP)
#define WEAK_INTERRUPT		error(1002)

extern unsigned enabled;

#define STRONG_INTERRUPT	{enabled=0;error(1003);}
#define INPUT_INTERRUPT		error(1004)
#define EOF_INTERRUPT		error(1005)
#define TIMEOUT			error(1006)
#define RESIZE			error(1007)		// GUI 
#define DEADLOCK		error(1008)


#define Assert(err,true)	if(!(true))error(err)

extern void 
	 syserror(unsigned)
	,syntax(void)
	,error(unsigned)
	,rankerr(void)
	,lengtherr(void)
	,domain(void)
	,nonce(void)
	,value(void)
	,internal(void)
	,limit(void)
	,nonce(void)
	,accesserr(void);

extern int in_syserror;
extern unsigned	weak,strong,resize;

typedef void (*ERRORTASK)(uns);
typedef void (*DESCALCTASK)(int);

#define SAVEENV(e) memcpy(save##e,e,sizeof(parse_jmp_buf))
#define RESTOREENV(e) memcpy(e,save##e,sizeof(parse_jmp_buf))

#define SAVEENV_FS(e) 		memcpy(save##e,e,sizeof(jmp_buf))
#define RESTOREENV_FS(e)	memcpy(e,save##e,sizeof(jmp_buf))


#define JMPVAR(type, name)	volatile type name = 0
#define JMPINT(name)		JMPVAR(int,name)

extern ERRORTASK errortask;				
extern DESCALCTASK descalctask;				

#if POCKET_H_INCLUDED

#include <setjmp.h>

#if	AP_BUILD
	// cover things that APL itself wants but are inappropriate in APs
	static void jwm_preerrortask(uns n) {}
	typedef enum
		{
		WS_MAIN = 4	// might as well make it the same as APL
		} WS;
	static WS switch_ws(WS ws) { return ws;}
	static WS this_ws(void)	{ return WS_MAIN; }
#endif//AP_BUILD

typedef struct
	{
	jmp_buf buf;
	LOCALP lp;
	ERRORTASK old_errortask;
	WS	workspace;
	} PROTECTEDSTATE;

#define PROTECTEDFN(fn)					\
static PROTECTEDSTATE *fn##_str_ptr;			\
							\
static void fn##_errortask(uns n)			\
{							\
switch_ws(WS_MAIN);	/* I think I am there anyway */	\
jwm_preerrortask(n);	/* in WS_MAIN */		\
switch_ws(fn##_str_ptr->workspace); /* in right ws */	\
cutp(&fn##_str_ptr->lp); /* so cut the right list */	\
longjmp(fn##_str_ptr->buf,n);				\
}							\
static int fn##_err;					\

#define PROTECTEDSTART(fn)				\
{							\
PROTECTEDSTATE *save_ptr=fn##_str_ptr;			\
PROTECTEDSTATE fn##_str;				\
fn##_str_ptr = &fn##_str;				\
fn##_str.old_errortask=errortask;			\
fn##_str.workspace=this_ws();				\
errortask = fn##_errortask;				\
regp(&fn##_str.lp);					\
if (0==(fn##_err=setjmp(fn##_str.buf)))			\
	{						

#define PROTECTEDRESET(fn)				\
	{						\
	errortask = fn##_str.old_errortask;		\
	fn##_str_ptr=save_ptr;				\
	}						

#define PROTECTEDELSE(fn)				\
	} else {					\
	PROTECTEDRESET(fn);				\
	regp(&fn##_str.lp);


#define PROTECTEDEND(fn)				\
	}						\
	gerp(&fn##_str.lp);				\
	PROTECTEDRESET(fn)				\
}						

#define PROTECTEDERR(fn)				\
	fn##_err

#define PROTECTEDLP(fn)					\
	fn##_str.lp					\

#endif // POCKET_H_INCLUDED

extern void jwm_preerrortask(unsigned int n);

#if	defined(ACCRUED_EXCEPTION)
	extern uns LIBCALL accrued_exception(void);
	extern uns decf_accrued_exception(void);
#else //defined(ACCRUED_EXCEPTION)
#	define	accrued_exception() 0
#endif//defined(ACCRUED_EXCEPTION)

#if	defined(DOS)
#define	testrong()	{if(enabled)strong_test();}
#else
#define	testrong()	{if(strong && enabled)STRONG_INTERRUPT}
#endif	// DOS 

extern void syserror(unsigned int code);
extern void syserror2(unsigned int code,int err);
extern void (*syserrortask)(uns err);

extern int W3SysError(gchar *msg,gchar * file,int code, int save);
extern void ODS(gchar *ods);

#if	defined(AP_BUILD)
#include	<assert.h>
#define AssertSysError(assertion, syserrnum, errnum) assert(assertion)
#else	//defined(AP_BUILD)
#define AssertSysError(assertion, syserrnum, errnum) {if (assertion) ; else syserror2(syserrnum, errnum);}
#endif 	//defined(AP_BUILD)

extern void aplcoredump(gchar *file);

extern unsigned int weak_test(void);
extern void GetQException(void);
extern unsigned int wscheck(int wid_check);
extern void WsCheckRequests(void);
extern void init_failure_message(const char *msg);
extern void w3error_error(void);
extern void w3limit_error(void);
extern void abort_dll(int code);

extern void LIBCALL strongint(int signo);
extern void LIBCALL weakint(int signo);
extern void LIBCALL winch(int signo);

extern gchar * limit_error_text;

extern achar Dsigbuf[256];
extern ubyte  Nsig;

extern void Raise_Exception(uns n);

extern void  error_with_msg(uns err, const gchar *msg);
#if HAS_UNICODE
extern void error_with_char_msg (unsigned int err, const char *text);
#else // HAS_UNICODE
#define error_with_char_msg error_with_msg
#endif

#include <qem.h>
#include <affirm.h>

#endif//defined(ERROR_H_INCLUDED)

//	Copyright (c) 1982 Dyadic Systems Limited	
