
//	Copyright (c) 1982 Dyadic Systems Limited	

#define	MSC	1		// using MSC
#define	FEXTEND	1		// append file extensions
#define	WINDOWS3	1	// specific WINDOWS system
#define	DOSWIN	1		// on dos platforms
#define	GUI	1		// generic enviroment

#define MSC_VER			7

#define WINVER          0x500
#define _WIN32_WINNT    0x500
#define _WIN32_IE 	0x500

extern int in_syserror;
#define snprintf	_snprintf	// MS not ISO compliant

#define _CRT_SECURE_NO_DEPRECATE 
#define _CRT_NONSTDC_DEPRECATE(_NewName)
#define _CRT_NON_CONFORMING_SWPRINTFS

#if xxBIT==32

	//#define  _M_IX86  	1

	#if !defined(_MANAGED)

	extern int __fastcall parse_setjmp(void *);
	extern int __fastcall parse_longjmp(void *,int);

	#define CALLED_BY_DWA_DLL __fastcall	// function is called by "Direct Workspace Access" PP/DLL 

	#endif // _MANAGED

	#define	ZONESBITFIELDTYPE	uint32_t
						// calling syntax must be matched by PP/DLL build
	#define LIBCALL __cdecl
	#define STACKCALL __cdecl
	#define PRINTF_MINT	GSTR("%I32i")	// MS doesn't have the j length qualifer
	#define PRINTF_MUNS	GSTR("%I32u")	// MS doesn't have the j length qualifer

	#define strtoimax	strtol	// not provided by lib. In contravention of C 99
	#define strtoumax	strtoul	// ditto

	#define wcstoumax	wcstoul
	#define wcstoimax	wcstol

	#define NEEDS_FPU_RESET 1	// Turn on protection against FPU corruption by rogue DLLs

	//#define _USE_32BIT_TIME_T

#else
	//#define  _M_AMD64  

	#define parse_longjmp(b,v)      longjmp((void *)b,v)
	#define parse_setjmp(b)         setjmp((void *)b)

	#define strtoimax	_strtoi64	// not supplied by compiler. ISO C 99
	#define strtoumax	_strtoui64	// ditto

	#define LIBCALL
	#define STACKCALL

	//#define	ZONESBITFIELDTYPE	uint64_t
	#define	ZONESBITFIELDTYPE	uint32_t
	#define PRINTF_MINT	GSTR("%I64i")	// MS doesn't have the j length qualifer
	#define PRINTF_MUNS	GSTR("%I64u")	// MS doesn't have the j length qualifer

#endif // xxBIT

#define strncasecmp	strnicmp
#define strcasecmp	stricmp

#define GSTAT struct _stat64 

#if !defined WINVER
#define WINVER		0x400
#endif

#define HAS_DOTNET		1
#define HAS_DOUBLEBUF		1
#define HAS_SEMAPHORES		1
#define HAS_OLE			1
#define HAS_DDE			1
#define HAS_TIMERS		1
#define HAS_SPY			1
#define HAS_VALUETIPS		1
#define HAS_POPUPHELP		1
#define HAS_HOTKEYS		1
#define HAS_THEMES		1
#define HAS_BOUNDEXE		1
#define HAS_XPLOOK		1
#define HAS_SETPROPCOVERS	1
#define HAS_UPDATERESOURCE	1
#define HAS_ONLINEHELP		1
#define HAS_LANGUAGEBAR		1
#define HAS_SKEYS		1
#define HAS_DIRLIST     	1
#define HAS_EMAIL		1

//#define HAS_APLDECF_BID		1	// use intel library
#define HAS_APLDECF_DPD		1	// use ibm library

#if HAS_UNICODE

	#if !APL_IME
		#define USES_IME	1
	#endif
#endif

#define MAIN(a,b) ein_main(a,b)

#define	BANNER1	""
#define	BANNER2	""

#define	ANSI	1
#define Ieee	1
#define PP0CHK	1

#if xxBIT==32

#define DALIGN	1

#define WARN_W64 __w64

// P4ALIGN:
// From: Intel Pentium 4 and Intel Xeon Processor Optimization
//     : Chapter 2
//  "A 64-byte or greater data structure or array should be aligned so that its base address is
//   a multiple of 64."
// Reckon the MS compiler should do this for us (we should have the "optimize for P4" option
// enabled) but it seems not to.

#define P4ALIGN __declspec(align(64))

#endif // xxBIT==32

#define	HERTZ	CLK_TCK		// 100

#define BYTE3210	1

#define	LOOP_UNROLL	1
#define ASM_OVER	1
#define HAS_FASTASM	1

#ifdef	DOS387  
#define ACCRUED_EXCEPTION 1
#endif	// DOS387 

#define	O_COMPAT	(SH_COMPAT << 16)
#define	O_DRW		(SH_DENYRW << 16)
#define	O_DW		(SH_DENYWR << 16)
#define	O_DR		(SH_DENYRD << 16)
#define	O_DN		(SH_DENYNO << 16)

typedef unsigned short ushort;	// not supplied in types.h
#define UNSIGNED unsigned
#define SIGNED signed

#define	SIGQUIT	SIGBREAK	// this is what we want
#define	SIGHUP	SIGILL		// MSC doesn't define SIGHUP or honour it if we
				// define it as 1. Pick one of theirs that we
				// don't use. Critical for clean exit of APs.
#define	SIGWINCH SIGILL		// ditto, this used to resize tty window
#define	SIGALRM	SIGTERM		// this is not a good map

#define PATH_MAX	259	// MSC don't define this (except for POSIX)

#define	ftruncate(h,s) chsize(h,(long)s)

#define	STRUCT_MAX_SIZE	(-4+64*1024)

#define FORCEINLINE __forceinline



#define __NT__

#	define __WINDOWS_16BIT__	0
#	define _STDCALL_SUPPORTED

#define	sigsetjmp(buf, save)	setjmp(buf)
#define	siglongjmp(buf, ret)	longjmp(buf, ret)
#define sigjmp_buf		jmp_buf

typedef unsigned char UCHAR;
//typedef unsigned char *UCP;
#define APLWCHAR APLWCHAR16	// eltype for native wchar_t


#define __syscall
#define __pascal

#if !APL_IME && !defined(_MANAGED)

//	Setting WRITLOSS to a non-zero value enables Write Loss testing for
//	component files. See writloss.h/writloss.c/Bug 3755.
#	define WRITLOSS 0

#if WRITLOSS
#define non_writloss_read 	win_read
#define non_writloss_write 	win_write
#define non_writloss_close 	win_close
#define non_writloss_lseek 	win_lseek
#else // WRITLOSS
#define read 	win_read
#define write 	win_write
#define close 	win_close
#define lseek 	win_lseek
#endif // WRITLOSS

extern int LIBCALL win_read(int,void *,unsigned);
extern int LIBCALL win_write(int,const void *,unsigned);
extern int LIBCALL win_close(int);
extern long LIBCALL win_lseek(int,long,int);

#endif

#define MSC_BODGE	1

#if defined(_MANAGED)
typedef struct _TREEITEM  { int dummy; } _TREEITEM;
typedef struct _IMAGELIST { int dummy; } _IMAGELIST;
typedef struct _PSP 	{ int dummy; } _PSP;
#endif //defined(_MANAGED)

#define WM_MOUSEWHEEL                   0x020A
#define WHEEL_DELTA                     120

#define SQRT_RETURNS_NAN 1				
	//For bug 10181 Microsoft visual C optimized library sqrt(-|x) returns 
	//	a indefinite NAN, and does not call matherr.



//typedef int ssize_t;

#define __thread	"don't use __thread http://support.microsoft.com/kb/118816"

// need our own thread safe malloc/free

//#define malloc	ts_malloc
//#define free	ts_free

//	Copyright (c) 1982 Dyadic Systems Limited	

